# THIS SCRIPT IS USED TO GENERATE CALL USING VOIPTG WITH MULTIPLE CONFIGURATION FILES.

#!/bin/bash
clear
echo "VoIPTG Traffic Generator"
j=1

#1. Input of the script : Define the path of the application [.jar file] 
echo "Please Enter the path of the .jar file:"
read filename

#2. Check the availability of the input files in the defined folder

#manage the relative paths
case $filename in
.*) filename=$PWD${filename:1}
esac

#remove last char if it is a /
lastchr=${filename#${filename%?}}
if [ $lastchr = / ]; then
  filename=${filename%/}
fi 

STRING=$filename'/input'
if [ -d $STRING ]; # d for checking folder
then
#3.Count number of files in the input directory. The number of files indicate the number of configuration files for call generation.
echo "Loading $(ls $STRING| wc -l) configuration files....."
else
echo "Configuration files missing.configuration file should be stored here: $STRING."
exit 1
fi


#4. Store input files name in an array
array=(`ls $STRING`)   # store input files in an array
len=${#array[*]}      # get length of the array=number of input files
#echo "It contains $len input files."

echo "                                                              "
echo "______________________________________________________________"
echo "______________________________________________________________"
echo "          Starting traffic generation                         "
echo "______________________________________________________________"
echo "______________________________________________________________"
echo "                                                              "

#visit the input folder with configuration files
cd $STRING
#Count the number of files containing 'G=t' property.
if [ $(grep -w G=t *.properties| wc -l) -gt 1 ];   # There should be only one configuration file with 'G=t' property. If there are more than one files with 'G=t'then it will show warning.
then
echo "Warning :  Multiple configuration files with good user description. Please check the configuration files. There should be only one input file containing 'G=t' property."
exit -1
else	
	# control the G value (type of traffic) in input files. If there is a wrong value (it is accept only 't' or 'f') the generator report an error
	i=0
	while [ $i -lt $len ]; do
		if [ $(grep -w G=t ${array[$i]}| wc -l) == 0 ];
		then 
			if [ $(grep -w G=f ${array[$i]}| wc -l) == 0 ];
			then 
				echo "WRONG type of traffic. You can choose between 't' (good) or 'f' (bad) in file: ${array[$i]}"
				exit -1
			else 
				#echo "good traffic"
				let i++
			fi
		else
			#echo "good traffic"
			let i++
		fi
	done

	# advice if there is no input files with good type of traffic
	if [ $(grep -w G=t *.properties| wc -l) == 0 ];
	then
		echo "Advice :  All configuration files generate bad traffic."
	fi

	# If there is only one file with 'G=t' property then find the file and invoke VoIPTG object to generate trace with good users.
	if [ $(grep -w G=t *.properties| wc -l) == 1 ];
	then
		gooduserfile="$(find $STRING | xargs grep G=t | cut -d ":" -f1 | uniq)"
		#echo "$gooduserfile"
		cd $filename    
		echo "                                                               "
		echo "--------------------------VoIPTG : 1-------------------------------"
		echo "Invoking new instance of VoIPTG with good user description"
		echo "Good Traffic= true"
		echo "______________________________________________________________"
		# Generate trace with configuration file containing good user description.
		java -jar "$filename/TrafficGenerator-v2.1.1.jar" $gooduserfile true general-input.properties 0
		let j++
	fi

fi


#5. Invoke objects of the VoIPTG to generate trace with other configuration files with 'G=f'
#visit directory of jar file
	cd $filename    

	
	i=0
	
	while [ $i -lt $len ]; do

		#echo "                                                               "
		#echo " ------------------------------------------------------------- "
		#echo "--------------------------VoIPTG :$j--------------------------"
		#echo "Invoking new instance of VoIPTG"
		#echo "Configuration file : ${array[$i] }"
		#echo "______________________________________________________________"
	
		# find the input file with good user description.
		inputfilename=$filename'/input/'${array[$i]}
		#echo $inputfilename		
                # search for configuration file with good user description.(parameter description 'G=t' indicates good users.)
		#COUNT=$(grep -c "G=t" $inputfilename)
		COUNT=$(grep -w G=t $inputfilename| wc -l)
		#echo $COUNT
		
				
	        if [ $COUNT -gt 0 ]; 
		then
			echo "     "
			#java -jar "$filename/TrafficGenerator-v2.1.1.jar" input/${array[$i]} true general-input.properties $j
			
		else
		echo "                                                               "
		echo " ------------------------------------------------------------- "
		echo "--------------------------VoIPTG : $j-------------------------------"
		echo "Invoking new instance of VoIPTG"
		echo "Configuration file : ${array[$i] }"
		echo "Good Traffic= false"
		echo "______________________________________________________________"
			#java -jar "$filename/TrafficGenerator-v2.1.1.jar" input/${array[$i]} false general-input.properties
			java -jar "$filename/TrafficGenerator-v2.1.1.jar" input/${array[$i]} false general-input.properties $j
			let j++
	fi
	let i++
	
	done

echo "_______________________________________________________________"
echo "_______________________________________________________________"



#Count the number of output files in the output directory to merger them in a txt file.

OUTPUTFOLDER=$filename'/Output'
outputarray=(`ls $OUTPUTFOLDER`)   # store name of the generated output files in an array
len=${#outputarray[*]}      # get length of the array=number of output files
echo "Generated output files : $len"


# merger all the output file in a txt file.

#[ -f 'Output/'output1.txt ] && echo "found" || echo "File does not exists"
#rm 'Output/'output1.txt
echo "__________________________________________________________"
#echo "Merging output files......"
echo "Clearing previous files......"
#outputdir=$filename'Output/'output.txt
outputdir=$filename'/'output.txt
if [ -f $outputdir ];
then
rm $outputdir
else
echo "...."
fi

echo "Merging the output files ....."

i=0
while [ $i -lt $len ]; do
	outputfile='Output/'${outputarray[$i]}
echo "output file $outputfile contains :"     
	wc -l 'Output/'${outputarray[$i]}
#	cat $outputfile>>'Output/'output.txt
	cat $outputfile>>output.txt
	let i++
done

echo "							"
#wc -l 'Output/'output.txt
echo "final output file contains calls:"
wc -l output.txt

#______________________________________________________________________________________________________
#______________________________________________________________________________________________________
#sort output file based on start time
sort -n -t, +3 -4 output.txt>output1.txt


#______________________________________________________________________________________________________
#___#Clearing output file with previous data 
#___________________________________________________________________________________________________
outputdir=$filename'/'Merged_Output.txt
#outputdir=Merged_Output.txt
if [ -f $outputdir ];
then
rm $outputdir
else
echo "...."
fi

#______________________________________________________________________________________________________
#___# Reassign call id to the sorted file.
#___________________________________________________________________________________________________
i=1
sep=$( printf ',') ## the colums in a row are separated by ',' in the output file.
#echo "">Merged_Output.txt
while IFS=$sep read a b c d e f g h
#while IFS=$sep read a b c 
do
    #echo "$a,$b,$i,$d,$e,$f,$g,$h">>Merged_Output.txt
	 echo "$a,$b,$i,$d,$e,$f,$g,$h">>Merged_Output.txt
	#echo "$i,$b,$c">>Merged_Output.txt
let i++
done < output1.txt


#______________________________________________________________________________________________________
#___# #add heading at the begining of the output file
#___________________________________________________________________________________________________

#sed -i  '1i UNITN' Merged_Output.txt  
#write the input file path at the beginning of the output file 
sed -i  '1i '$STRING'' Merged_Output.txt


#______________________________________________________________________________________________________
#___# #Final output file is Merged_Output.txt
#___________________________________________________________________________________________________
echo "                                                              "
echo "______________________________________________________________"
echo "______________________________________________________________"
echo "        FInal Output file = Merged_Output.txt                 "
echo "______________________________________________________________"
echo "______________________________________________________________"
echo "                                                              "
#echo "Final output file = Merged_Output.txt"	
#wc -l 'Output/'output.txt
echo " Merged_Output.txt contains call:"
wc -l Merged_Output.txt



#______________________________________________________________________________________________________
#___# #Removed unused output file output.txt and output1.txt
#___________________________________________________________________________________________________
#if [ -f $filename'/output.txt' ]
#then
#  rm $filename'/output.txt'
#fi

#if [ -f $filename'/output1.txt' ]
#then
#  rm $filename'/output1.txt'
#fi

